import { ActionFluentOptions, ActionPayload, StateDefinition, StateFluentOptions, StateFluentOptionsEx, StateMachineOptions, TransitionMethod } from "../common";
import { Arc, ArcCreator } from "./common";
export declare class ActionOptions<TState, TAction> implements ActionFluentOptions<TState, TAction>, ArcCreator<TState, TAction> {
    private sourceStates;
    private actionType;
    private smOptions;
    private stateOptions;
    private transitions;
    private targetState?;
    constructor(sourceStates: string[], actionType: string, smOptions: StateMachineOptions<TState>, stateOptions: StateFluentOptions<TState>);
    goTo(state: StateDefinition<TState, TAction>): StateFluentOptionsEx<TState>;
    execute(transition: TransitionMethod<TState, TAction>): ActionFluentOptions<TState, TAction>;
    noop(): StateFluentOptionsEx<TState>;
    createArcs(): Arc<TState, ActionPayload>[];
}
