import { ActionPayload, StateDefinition, TransitionMethod } from "../common";
export interface Node<TState, TPayload extends ActionPayload = void> {
    entry: StateDefinition<TState, TPayload>;
    actions: Edge<TState, TPayload>[];
}
export interface Edge<TState, TPayload extends ActionPayload = void> {
    targetState?: string;
    actionType: string;
    transitions: TransitionMethod<TState, TPayload>[];
}
export interface Arc<TState, TPayload extends ActionPayload = void> extends Edge<TState, TPayload> {
    sourceState: string;
}
export interface ArcCreator<TState, TPayload extends ActionPayload = void> {
    createArcs(): Arc<TState, TPayload>[];
}
